import java.util.LinkedHashSet;

// Copyright Florent Madelaine, (3 juin 2020) 

// florent.madelaine@u-pec.fr

// Ce logiciel est un programme informatique simulant une petite partie du jeu de Memory

// Ce logiciel est regi par la licence CeCILL soumise au droit francais et
// respectant les principes de diffusion des logiciels libres. Vous pouvez
// utiliser, modifier et/ou redistribuer ce programme sous les conditions
// de la licence CeCILL telle que diffusee par le CEA, le CNRS et l'INRIA 
// sur le site "http://www.cecill.info".

// En contrepartie de l'accessibilite au code source et des droits de copie,
// de modification et de redistribution accordes par cette licence, il n'est
// offert aux utilisateurs qu'une garantie limitee.  Pour les memes raisons,
// seule une responsabilite restreinte pese sur l'auteur du programme,  le
// titulaire des droits patrimoniaux et les concedants successifs.

// A cet egard  l'attention de l'utilisateur est attiree sur les risques
// associes au chargement,  a l'utilisation,  a la modification et/ou au
// developpement et a la reproduction du logiciel par l'utilisateur etant 
// donne sa specificite de logiciel libre, qui peut le rendre complexe a 
// manipuler et qui le reserve donc a des developpeurs et des professionnels
// avertis possedant  des  connaissances  informatiques approfondies.  Les
// utilisateurs sont donc invites a charger  et  tester  l'adequation  du
// logiciel a leurs besoins dans des conditions permettant d'assurer la
// securite de leurs systemes et ou de leurs donnees et, plus generalement, 
// a l'utiliser et l'exploiter dans les memes conditions de securite. 

// Le fait que vous puissiez acceder a cet en-tete signifie que vous avez 
// pris connaissance de la licence CeCILL, et que vous en avez accepte les
// termes.

/**
 * Classe servant a representer le joueur dans le modele.
 * Pour l'instant juste un nom et un ensemble de cartes
 */
public class Joueur extends EnsembleCarte {
    /**
    * Nom du joueur
    */
    private String nom;
    
    /**
     * Constructeur
     * @param  nom Futur nom du joueur, ne doit pas etre null
     * @throws nullPointerException si nom est null.
     */
    public Joueur(String nom){
        this.nom=nom;
    }

    public String toString(){
        return "Joueur " + this.nom + " " + super.toString();
    }


    public static void main(String[] args) {
        // c'est un peu moche mais on peut pour simplifier mettre des tests manuels dans un main dans chaque classe.
        // C'est plutot mieux que de mettre des print dans chaque methode car vous etes plus sur de la stabilite de vos tests (vous pouvez rejouer les tests plus tard).

        // Les Joueurs
        Joueur toto = new Joueur("Toto");
        Joueur titi = new Joueur("Titi");
        Joueur tata = new Joueur("Tata");
        
        // Les cartes
        Carte un = new Carte(1);
        Carte deux = new Carte (2);
        Carte unBis = new Carte(1);
        Carte deuxBis = new Carte(2);

        // la Table
        Table t = new Table();
        t.add(un);
        t.add(deux);
        t.add(unBis);
        t.add(deuxBis);

        System.out.println(t);
        System.out.println(toto);

        t.reveler(un);
        t.reveler(unBis);

        t.transfer(toto,un,unBis);
        
        System.out.println(t);
        System.out.println(toto);	
    }
}


